package org.apache.commons.lang3.function;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.Objects;

@FunctionalInterface
public interface FailableBiPredicate<T, U, E extends Throwable> {
  public static final org.apache.commons.lang3.function.FailableBiPredicate FALSE = (t, u) -> false;
  
  public static final org.apache.commons.lang3.function.FailableBiPredicate TRUE = (t, u) -> true;
  
  static <T, U, E extends Throwable> org.apache.commons.lang3.function.FailableBiPredicate<T, U, E> falsePredicate() {
    return FALSE;
  }
  
  static <T, U, E extends Throwable> org.apache.commons.lang3.function.FailableBiPredicate<T, U, E> truePredicate() {
    return TRUE;
  }
  
  default org.apache.commons.lang3.function.FailableBiPredicate<T, U, E> and(org.apache.commons.lang3.function.FailableBiPredicate<? super T, ? super U, E> other) {
    Objects.requireNonNull(other);
    return (t, u) -> (test((T)t, (U)u) && other.test(t, u));
  }
  
  default org.apache.commons.lang3.function.FailableBiPredicate<T, U, E> negate() {
    return (t, u) -> !test((T)t, (U)u);
  }
  
  default org.apache.commons.lang3.function.FailableBiPredicate<T, U, E> or(org.apache.commons.lang3.function.FailableBiPredicate<? super T, ? super U, E> other) {
    Objects.requireNonNull(other);
    return (t, u) -> (test((T)t, (U)u) || other.test(t, u));
  }
  
  boolean test(T paramT, U paramU) throws E;
}
